#!/usr/bin/env python2.7

import sys
from heapq import heappush, heappop

n, m = map(int, sys.stdin.readline().split())
adj = [[] for _ in range(n)]
for _ in range(m):
    u, v, c = map(int, sys.stdin.readline().split())
    u -= 1
    v -= 1
    adj[u].append((v, c))
    adj[v].append((u, c))
s = int(sys.stdin.readline())
s -= 1

dist = [None] * n
dist[s] = 0

mindist = None
maxdist = None

heap = []
heappush(heap, (dist[s], s))
while len(heap) > 0:
    d, u = heappop(heap)
    if dist[u] < d:
        continue

    if u != s:
        if mindist is None or dist[u] < mindist:
            mindist = dist[u]
        if maxdist is None or dist[u] > maxdist:
            maxdist = dist[u]

    for v, c in adj[u]:
        if dist[v] is None or dist[u] + c < dist[v]:
            dist[v] = dist[u] + c
            heappush(heap, (dist[v], v))

assert(mindist is not None)
assert(maxdist is not None)
assert(mindist <= maxdist)
assert(None not in dist)

print (maxdist - mindist)
